--- old/usr/src/cmd/sgs/Makefile	2016-11-25 20:11:15.016919224 +0000
+++ new/usr/src/cmd/sgs/Makefile	2016-11-25 20:11:15.028275790 +0000
@@ -159,7 +159,7 @@
 # itself and ld.so.1.  Once this new functionality appears in the standard ld
 # this target can be disabled.
 
-native-add:	native-proto FRC
+native-add:	FRC
 		@ cd tools/$(MACH); pwd; $(MAKE) native
 		@ cd libconv/$(MACH); pwd; $(MAKE)
 		@ cd libelf/$(MACH); pwd; $(MAKE) native
@@ -172,12 +172,6 @@
 		@ cd tools; pwd; $(MAKE) $(TARGET)
 		$(RM) -r proto/$(MACH)
 
-native-proto:
-		-@mkdir -p proto/$(MACH)
-		-@mkdir -p proto/$(MACH)/lib
-		-@mkdir -p proto/$(MACH)/usr
-		-@mkdir -p proto/$(MACH)/usr/bin
-
 FRC:
 
 #
--- old/usr/src/cmd/sgs/Makefile.targ	2016-11-25 20:11:15.303250563 +0000
+++ new/usr/src/cmd/sgs/Makefile.targ	2016-11-25 20:11:15.313167157 +0000
@@ -21,6 +21,7 @@
 
 #
 # Copyright (c) 1998, 2010, Oracle and/or its affiliates. All rights reserved.
+# Copyright 2016 RackTop Systems.
 #
 
 # Standard install rules
@@ -231,4 +232,19 @@
 $(ROOTFS_LIBDIR64)/$(LIBLINKSCCC): $(ROOTFS_LIBDIR64)/$(LIBLINKSCCC)$(VERS)
 	$(INS.liblinkccc64)
 
+#
+# For those that install into the SGSPROTO directory.
+#
+$(SGSPROTO):
+	$(INS.dir)
+
+$(SGSBINDIR): $(SGSPROTO)
+	$(INS.dir)
+
+$(SGSPREFIX): $(SGSPROTO)
+	$(INS.dir)
+
+$(SGSLIBDIR): $(SGSPREFIX)
+	$(INS.dir)
+
 FRC:
--- old/usr/src/cmd/sgs/ld/Makefile.targ	2016-11-25 20:11:15.598650078 +0000
+++ new/usr/src/cmd/sgs/ld/Makefile.targ	2016-11-25 20:11:15.608074288 +0000
@@ -35,7 +35,9 @@
 		$(COMPILE.c) $<
 		$(POST_PROCESS_O)
 
-$(PROG):	$(MAPFILES)
+$(PROG):	$(OBJS) $(MAPFILES)
+		$(LINK.c) $(OBJS) -o $@ $(LDLIBS)
+		$(POST_PROCESS)
 
 clean:
 		$(RM) $(OBJS) $(CLEANFILES)
@@ -53,8 +55,7 @@
 
 native:		$(SGSBINDIR)/$(PROG)
 
-$(SGSBINDIR)/$(PROG) \
-$(PROG):	$$(OBJS)
+$(SGSBINDIR)/$(PROG):	$(OBJS) $(SGSBINDIR)
 		$(LINK.c) $(OBJS) -o $@ $(LDLIBS)
 		$(POST_PROCESS)
 
--- old/usr/src/cmd/sgs/libelf/Makefile.targ	2016-11-25 20:11:15.886706740 +0000
+++ new/usr/src/cmd/sgs/libelf/Makefile.targ	2016-11-25 20:11:15.896442782 +0000
@@ -134,7 +134,9 @@
 
 native:		$(SGSLIBDIR)/$(LIBLINKS)
 
-$(SGSLIBDIR)/$(DYNLIB): pics .WAIT $$(PICS)
+$(PICS):	pics
+
+$(SGSLIBDIR)/$(DYNLIB): $(PICS) $(SGSLIBDIR)
 		$(BUILD.SO)
 		$(POST_PROCESS_SO)
 
--- old/usr/src/cmd/sgs/libld/Makefile.targ	2016-11-25 20:11:16.184461890 +0000
+++ new/usr/src/cmd/sgs/libld/Makefile.targ	2016-11-25 20:11:16.195452335 +0000
@@ -103,7 +103,9 @@
 
 native:		$(SGSLIBDIR)/$(LIBLINKS)
 
-$(SGSLIBDIR)/$(DYNLIB): pics .WAIT $$(PICS)
+$(PICS):	pics
+
+$(SGSLIBDIR)/$(DYNLIB): $(PICS) $(SGSLIBDIR)
 		$(BUILD.SO)
 		$(POST_PROCESS_SO)
 
--- old/usr/src/cmd/sgs/liblddbg/Makefile.targ	2016-11-25 20:11:16.487799948 +0000
+++ new/usr/src/cmd/sgs/liblddbg/Makefile.targ	2016-11-25 20:11:16.503518648 +0000
@@ -57,7 +57,9 @@
 
 native:		$(SGSLIBDIR)/$(LIBLINKS)
 
-$(SGSLIBDIR)/$(DYNLIB): pics .WAIT $$(PICS)
+$(PICS):	pics
+
+$(SGSLIBDIR)/$(DYNLIB): $(PICS) $(SGSLIBDIR)
 		$(BUILD.SO)
 		$(POST_PROCESS_SO)
 
--- old/usr/src/cmd/sgs/libldstab/Makefile.targ	2016-11-25 20:11:16.831254460 +0000
+++ new/usr/src/cmd/sgs/libldstab/Makefile.targ	2016-11-25 20:11:16.845446171 +0000
@@ -43,7 +43,9 @@
 
 native:		$(SGSLIBDIR)/$(DYNLIB)
 
-$(SGSLIBDIR)/$(DYNLIB): pics .WAIT $$(PICS)
+$(PICS):	pics
+
+$(SGSLIBDIR)/$(DYNLIB): $(PICS) $(SGSLIBDIR)
 		$(BUILD.SO)
 		$(POST_PROCESS_SO)
 
--- old/usr/src/cmd/sgs/librtld/Makefile.targ	2016-11-25 20:11:17.151418306 +0000
+++ new/usr/src/cmd/sgs/librtld/Makefile.targ	2016-11-25 20:11:17.164268972 +0000
@@ -40,7 +40,9 @@
 
 native:		$(SGSLIBDIR)/$(LIBLINKS)
 
-$(SGSLIBDIR)/$(DYNLIB): pics .WAIT $$(PICS)
+$(PICS):	pics
+
+$(SGSLIBDIR)/$(DYNLIB): $(PICS) $(SGSLIBDIR)
 		$(BUILD.SO)
 		$(POST_PROCESS_SO)
 
